oracle.xml.parser.schema

## Class XSDBuilder

- java.lang.Object
- - oracle.xml.parser.schema.XSDBuilder

All Implemented Interfaces:
  XSDConstantValues

    public class XSDBuilder
    extends java.lang.Object
    implements XSDConstantValues

Builds an XMLSchema object from XMLSchema document. XMLSchema object is a set of objects (Infoset items) corresponding to top-level schema declarations and definitions. The Schema document is parsed as XML and converted to a DOM tree. This schema DOM tree is 'Schema' parsed in the following order: <import> (if any) builds a schema object and makes it visible. <include> (if any) is replaced by corresponding DOM tree. Top-level declarations and definitions are registered as the current schema infoset items. Finally, top-level tree elements (infoset items) are 'Schema' parsed. Those include <element>, <simpleType>, <complexType>, <annotation>, <group>, <attribute>, <attributeGroup>, <notation>, etc. The result XMLSchema object is a set (infoset) of objects (top-level input elements). Object's contents is a tree with nodes corresponding to low-level element/group decls/refs preceded by node/object of type XSDNode containg cardinality info (minOccurs/maxOccurs).

### Field Summary

Fields
`static java.lang.String` `ANNOTATION_CONTEXT`
`static java.lang.String` `IGNORE_DUPLICATE`
`static java.lang.String` `IGNORE_DUPLICATES`
`static java.lang.String` `IMPORT_INCLUDE_ERROR`
`static java.lang.String` `INCREMENTAL_BUILD`
`static java.lang.String` `KEEP_DOM_NODE`
`static java.lang.String` `NAMESPACE_CONTEXT`
`static java.lang.String` `SCHEMA_ANNOTATION`
`static java.lang.String` `SORT_SCHEMA_IMPORTS`
`static java.lang.String` `SQL_OFFLINE_SIZE`
`static java.lang.String` `XDB_SQLINLINE`

### Fields inherited from interface oracle.xml.parser.schema.XSDConstantValues

`_abstract, _all, _annotation, _any, _anyAttribute, _anySimpleType, _anyType, _appinfo, _attrFormDefault, _attribute, _attributeGroup, _attrTag, _base, _block, _blockDefault, _choice, _complexContent, _complexType, _content, _default, _derivedBy, _documentation, _element, _elementOnly, _elemFormDefault, _empty, _enumeration, _equivClass, _extension, _false, _field, _final, _finalDefault, _fixed, _form, _group, _id, _import, _include, _itemType, _key, _keyref, _lax, _list, _maxOccurs, _memberTypes, _minOccurs, _mixed, _nall, _name, _namespace, _nil, _nillable, _nnany, _nnlist, _nnlocal, _nnother, _nntargetNS, _noNSSchemaLocation, _notation, _null, _nullable, _optional, _pattern, _processContents, _prohibited, _publicid, _qualified, _redefine, _ref, _refer, _required, _restriction, _restrictions, _schemaLocation, _selector, _sequence, _simpleContent, _simpleType, _skip, _strict, _substitution, _substitutionGrp, _systemid, _targetNS, _textOnly, _this, _true, _type, _undef, _union, _unique, _unqualified, _use, _value, _version, _xmlns, ABSENT_NS, ACCEPTED, ALL, ANNOTATION, ANY, ANY_ATTRIBUTE, ANY_NODE, ATTRIBUTE, ATTRIBUTE_GROUP, AUTO_VALIDATION, BASE_RESOLVED, BASE_UNRESOLVED, BASE_URL, BUILD_FAIL, CHOICE, CIRCULAR_SUBST, CONFLICIT_FACET, constName, DATATYPE, DEEP_VALIDATION, derivationBlock, DONE, DUPLICATE_DEF, duplicateId, ELEMENT, ELEMENT_CHILD, ELEMENT_ONLY, elemNotNullable, EMPTY, ENTITY_RESOLVER, EQUIV_RESOLVED, EQUIV_UNRESOLVED, ERROR, EXTENTION, FACET_CHILD, FAKE_ATTR, FAKE_NODE, FIXED_SCHEMA, GROUP, IABSTRACT, IBLOCKEXT, IBLOCKRST, IBLOCKSUB, IDENTITY_ERROR, IDENTITY_KEY, IDENTITY_KEYREF, IDENTITY_UNIQUE, IFINALEXT, IFINALLIST, IFINALRST, IFINALUNION, IMPORT, INCLUDE, INCORRECT_ATTR, INCORRECT_ELEM, INFINITY, INTERNAL_ERROR, INVALID_DATE, INVALID_DATETIME, INVALID_DERIVATION, INVALID_FACET, INVALID_FACET_VALUE, INVALID_NOTATION, INVALID_REGEX, INVALID_SCHEMA_NS, INVALID_TIME, INVALID_TYPE_VALUE, invalidAttr, invalidAttrVal, invalidChars, invalidElem, invalidFixedChars, invalidNS, invalidPrefix, invalidProperty, invalidRef, invalidSubstitution, invalidTargetNS, LAX_VALIDATION, MISSING_NS, missingAttr, MIXED, NEW_STATE, NO_CHILD, noDefinition, NOT_DONE, NOTATION, notComplete, notSubstitutable, notSubTypeOf, NS_CONFLICT, NS_DIF_SPECIFIED, NS_NOT_ALLOWED, NS_NOT_EXPECTED, NS_NOT_SAME, NS_RESOLVER, REDEFINE, REF_RESOLVED, REF_UNRESOLVED, RESTRICTION, ROOT_ELEMENT, ROOT_NODE, ROOT_TYPE, SCHEMA_NS, SCHEMA_RESOLVER, SEQ, STRICT_VALIDATION, TEXT_ONLY, TOP_LEVEL, TYPE, TYPE_RESOLVED, TYPE_UNRESOLVED, UNDEF, unexpectedAttr, unexpectedElem, VALIDATION_MODE, VIOLATE_FACET, XSDRECNS, XSDRECTYPENS, XSIRECNS, XSITYPE_ABSENT`

### Constructor Summary

Constructors
Constructor and Description
`XSDBuilder()` XSDBuilder constructor

### Method Summary

All Methods Instance Methods Concrete Methods
`XMLSchema` `build(InputSource source)` Build an XMLSchema object
`XMLSchema` `build(java.io.InputStream in, java.net.URL baseurl)` Build an XMLSchema object
`XMLSchema` `build(java.io.Reader r, java.net.URL baseurl)` Build an XMLSchema object
`XMLSchema` `build(java.lang.String sysId)` Build an XMLSchema object
`XMLSchema` `build(java.lang.String ns, java.lang.String sysid)` Build an XMLSchema object
`XMLSchema` `build(java.lang.String ns, java.net.URL sysid)` Build an XMLSchema object
`XMLSchema` `build(java.net.URL schemaurl)` Build an XMLSchema object
`XMLSchema` `build(XMLDocument[] schemaDoc)` Build XMLSchema from a set of XML documents The system id of each document is used as the based uri
`XMLSchema` `build(XMLDocument[] schemaDoc, java.net.URL baseurl)` Build XMLSchema from a set of XML documents
`XMLSchema` `build(XMLDocument doc, java.lang.String fragment, java.lang.String ns, java.net.URL baseurl)` Build an XMLSchema object
`XMLSchema` `build(XMLDocument schemaDoc, java.net.URL baseurl)` Build XMLSchema from XML document
`XMLSchema` `build(XMLElement[] schemaDoc, java.net.URL baseurl)` Build XMLSchema from a set of XMLElements
`java.lang.Object` `getObject()` Returns the schema object.
`java.util.HashSet` `getSchemaCircle()`
`void` `setDebugMode(boolean mode)` Sets debug mode.
`void` `setEntityResolver(EntityResolver entResolver)` Set an EntityResolver for resolving imports/include
`void` `setError(XMLError er)` Sets XMLError object.
`void` `setJAXP(boolean jaxp)` Set JAXP mode, in this mode, only resolved URI will be sent to entityResolver.
`void` `setLocale(java.util.Locale locale)` Sets locale for error reporting.
`void` `setXMLProperty(java.lang.String name, java.lang.Object value)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### SCHEMA_ANNOTATION

    public static final java.lang.String SCHEMA_ANNOTATION

See Also:
  Constant Field Values

#### XDB_SQLINLINE

    public static final java.lang.String XDB_SQLINLINE

See Also:
  Constant Field Values

#### SQL_OFFLINE_SIZE

    public static final java.lang.String SQL_OFFLINE_SIZE

See Also:
  Constant Field Values

#### SORT_SCHEMA_IMPORTS

    public static final java.lang.String SORT_SCHEMA_IMPORTS

See Also:
  Constant Field Values

#### ANNOTATION_CONTEXT

    public static final java.lang.String ANNOTATION_CONTEXT

See Also:
  Constant Field Values

#### KEEP_DOM_NODE

    public static final java.lang.String KEEP_DOM_NODE

See Also:
  Constant Field Values

#### INCREMENTAL_BUILD

    public static final java.lang.String INCREMENTAL_BUILD

See Also:
  Constant Field Values

#### NAMESPACE_CONTEXT

    public static final java.lang.String NAMESPACE_CONTEXT

See Also:
  Constant Field Values

#### IMPORT_INCLUDE_ERROR

    public static final java.lang.String IMPORT_INCLUDE_ERROR

See Also:
  Constant Field Values

#### IGNORE_DUPLICATES

    public static final java.lang.String IGNORE_DUPLICATES

See Also:
  Constant Field Values

#### IGNORE_DUPLICATE

    public static final java.lang.String IGNORE_DUPLICATE

See Also:
  Constant Field Values

### Constructor Detail

#### XSDBuilder

    public XSDBuilder()
               throws XSDException

XSDBuilder constructor

Throws:
  `XSDException`

### Method Detail

#### setError

    public void setError(XMLError er)

Sets XMLError object.

Parameters:
  `er` - XMLError object

#### setDebugMode

    public void setDebugMode(boolean mode)

Sets debug mode.

Parameters:
  `mode` - boolean

#### setLocale

    public void setLocale(java.util.Locale locale)

Sets locale for error reporting.

Parameters:
  `locale` - Locale object

#### setEntityResolver

    public void setEntityResolver(EntityResolver entResolver)

Set an EntityResolver for resolving imports/include

Parameters:
  `entResolver` - EntityResolver
See Also:
  `EntityResolver`

#### setJAXP

    public void setJAXP(boolean jaxp)

Set JAXP mode, in this mode, only resolved URI will be sent to entityResolver.

Parameters:
  `java` - - true for JAXP mode

#### setXMLProperty

    public void setXMLProperty(java.lang.String name,
                               java.lang.Object value)
                        throws java.lang.IllegalArgumentException

Throws:
  `java.lang.IllegalArgumentException`

#### getSchemaCircle

    public java.util.HashSet getSchemaCircle()

#### getObject

    public java.lang.Object getObject()

Returns the schema object.

Returns:
  XMLSchema object.

#### build

    public XMLSchema build(java.lang.String sysId)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `sysId` - Schema location
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(java.io.InputStream in,
                           java.net.URL baseurl)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `in` - Inputstream of Schema
  `baseurl` - URL used to resolve any relative refs.
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(java.io.Reader r,
                           java.net.URL baseurl)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `r` - Reader of Schema
  `baseurl` - URL used to resolve any relative refs.
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(java.net.URL schemaurl)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `url` - URL of Schema
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(InputSource source)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `InputSource` - of Schema
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(XMLDocument schemaDoc,
                           java.net.URL baseurl)
                    throws XSDException

Build XMLSchema from XML document

Parameters:
  `schemaDoc` - XMLDocument
  `baseurl` - base URL to be use for any import/include in document
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(XMLDocument[] schemaDoc,
                           java.net.URL baseurl)
                    throws XSDException

Build XMLSchema from a set of XML documents

Parameters:
  `schemaDoc` - Array of XMLDocument
  `baseurl` - base URL to be use for any import/include in document
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(XMLDocument[] schemaDoc)
                    throws XSDException

Build XMLSchema from a set of XML documents The system id of each document is used as the based uri

Parameters:
  `schemaDoc` - Array of XMLDocument
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(XMLElement[] schemaDoc,
                           java.net.URL baseurl)
                    throws XSDException

Build XMLSchema from a set of XMLElements

Parameters:
  `schemaDoc` - Array of XMLElement
  `baseurl` - base URL to be use for any import/include in document
Returns:
  Object - XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(XMLDocument doc,
                           java.lang.String fragment,
                           java.lang.String ns,
                           java.net.URL baseurl)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `doc` - XMLdocument contain the schema element
  `fragment` - Fragment ID of the schema element
  `ns` - Schema target namespace used to validate targetNamespace
  `sysId` - Schema location
Returns:
  Object XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(java.lang.String ns,
                           java.lang.String sysid)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `ns` - Schema target namespace used to validate targetNamespace
  `sysId` - Schema location
Returns:
  Object XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

#### build

    public XMLSchema build(java.lang.String ns,
                           java.net.URL sysid)
                    throws XSDException

Build an XMLSchema object

Parameters:
  `ns` - Schema target namespace used to validate targetNamespace
  `sysId` - URL Schema location
Returns:
  Object XMLSchema
Throws:
  `XSDException` - An `XSDException` is thrown if Builder fails to build an XMLSchema object.

Copyright © 2003, 2017, Oracle and/or its affiliates. All rights reserved.